# AMBIENTE LOCAL PARA DESARROLLADORES (MRDEVS TOOLS)
## GUÍA PARA DESARROLLADORES - REV. 17/12/2024

### PREPARACIÓN DE AMBIENTE LOCAL PARA DESARROLLADORES

#### Creación del área local de trabajo para desarrolladores

En la carpeta $HOME descargue el repositorio devs (la carpeta no debe existir):

    $ cd $HOME
    $ git clone https://git.rosero.one/mrosero/devs.git

**Nota:** Previamente, debe tener instalado el comando git.

#### Instalación de herramientas básicas y de gestión de contenedores 

A partir de este momento, la carpeta <u>**$HOME/devs**</u> será nuestra área de desarrollo; donde se descargaran los diversos ambientes de desarrollo y proyectos gestionados. Como primer paso instalaremos las herramientas básicas y de gestión de contenedores. Por razones de seguridad, priorizamos el uso de [podman](https://podman.io/) sobre [docker](https://www.docker.com/) como gestor de contendores.

Sí deseas usar [docker](https://www.docker.com/) en vez de [podman](https://podman.io/) deberás instalar [docker](https://www.docker.com/) manualmente antes de ejecutar esto:

    $ cd $HOME/devs
    $ bin/bootstrap.sh

#### Actualización de ambiente local de desarrollo

Actualice los nuevos cambios y funcionalidades del ambiente de desarrollo local raíz

    $ cd $HOME/devs
    $ bin/update.sh

### ACCESO VPN A INFRAESTRUCTURA MRDEVS PARA DESARROLLADORES

#### Instalación de Cliente Pritunl VPN con ambiente GUI (gráfico)

Para tener acceso a todos los recursos y servidores de desarrollo se requiere acceder vía VPN a nuestra infraestructura de desarrollo. Para esto, requieres tener una cuenta de desarrollador con nosotros y posteriormente instalar el [Cliente PRITUNL](https://client.pritunl.com/) como sigue:

    $ cd $HOME/devs
    $ bin/vpn_install.sh [--help] [--version] [--update]

Nota: En determinadas versiones, las actualizaciones a partir de los repositorios no es posible por lo que usamos el argumento --update. Si no eres desarrollador nuestro, puedes obviar este paso y los siguientes relacionados a acceso VPN.

#### Instalación de Cliente OpenVPN con ambiente TUI (texto)

(pendiente)

#### Obtener archivo de configuración para acceso VPN

(pendiente)

### GESTIONANDO PERIFL DEL DESARROLLADOR

#### Inicialización de carpeta de accesos SSH para desarrolladores

(pendiente)

#### Configuración por defecto de comportamineto GPG

En la carpeta **$HOME/devs/bin/config** existe un archivo de configuración **gpg.config** que contiene los parámetros de comportamiento por defecto para **[GNUGP](https://gnupg.org/)** que son los recomendados para el uso de la plataforma. Si tienes alguno en uso, está función le sacará previamente una copia y aplicará el de la plataforma siguiendo los siguientes pasos:

    $ cd $HOME/devs
    $ bin/gpg_init.sh

#### Copia de seguridad básica del perfil del desarrollador

Para realizar una copia de seguridad de sus configuraciones de desarrollador que involucran claves GPG, claves SSH, configuración GIT y otros, ejecute los siguientes comandos:

    $ cd $HOME/devs
    $ bin/profile_backup.sh

Nota: Solo utilice está función si realiza cambios a su configuración GIT, GPG o SSH. Esto creará un archivo zip en la carpeta $HOME/secure/backups (por defecto). En la carpeta de backups podrán existir múltiples archivo zip (uno por cada vez que se realizó un backup) y deberá un archivo gpg.secret que contedrá la contraseña encriptada para restaurar el backup. Si pierde o elimina el archivo de secretos la restauración no podrá ser realizada. El archivo de secretos solo será creado si no existe. Su contenido no debe ser modificado. Procuré no tener archivos ZIP que no correspondan a la contraseña vigente; ya que estos no podrán ser restaurados.

#### Restaurando configuraciones del perfil del desarrollador

Para poder restaurar el perfil de desarrollador de una copia de seguridad realice las siguientes operaciones:

    $ cd $HOME/devs
    $ bin/profile_restore.sh <backup zipfile> [--help] [--version]

Donde **<backup zipzile>** debe ser la ruta al archivo de copia de seguridad del perfil de desarrollador que se desea restaurar. Esto es útil cuando el desarrollador tiene diferentes dispositivos de trabajo.

#### Enviando secure a repositorio central

(pendiente)

#### Obtebiendo secure desde repositorio central

(pendiente)

### AMBIENTE DE DESARROLLO ODOO

#### Preparación de ambiente local de desarrollo Odoo

Instale el área de trabajo para desarrollo de proyectos Odoo

    $ cd $HOME/devs
    $ bin/odoodevs_set.sh